#include <iostream>
#include <string>
#include <fstream>
#include <sstream>
#include <WS2tcpip.h>

#pragma comment(lib, "ws2_32.lib")


const std::string rootDirectory = "C:/Users/Starry/Desktop/γ/9 Web Server ʵ/web_server";

// Ĭ϶˿
const int DEFAULT_PORT = 8080;

// ȡļݲΪַ
std::string GetFileContent(const std::string& filePath) {
    std::ifstream file(filePath);
    std::ostringstream content;
    content << file.rdbuf();
    return content.str();
}

// HTTPĺ
void HandleHttpRequest(SOCKET clientSocket) {
    // HTTPӦͷ
    const std::string responseHeader = "HTTP/1.1 200 OK\r\nContent-Type: text/html; charset=utf-8\r\n\r\n";

    // HTTP
    char buffer[1024];
    memset(buffer, 0, sizeof(buffer));
    recv(clientSocket, buffer, sizeof(buffer), 0);

    // HTTP
    std::string request = buffer;
    size_t start = request.find("GET ") + 4;
    size_t end = request.find(" HTTP/");
    std::string path = request.substr(start, end - start);

    // ļ·
    std::string filePath = rootDirectory + path;

    // HTTPӦ
    std::string responseBody = GetFileContent(filePath);
    std::string response = responseHeader + responseBody;
    send(clientSocket, response.c_str(), response.size(), 0);
}

int main() {
    // ʼ Winsock
    WSADATA wsData;
    WORD ver = MAKEWORD(2, 2);

    if (WSAStartup(ver, &wsData) != 0) {
        std::cerr << "ʼ Winsock ʧ" << std::endl;
        return -1;
    }

    // ׽
    SOCKET listenSocket = socket(AF_INET, SOCK_STREAM, 0);
    if (listenSocket == INVALID_SOCKET) {
        std::cerr << "׽ʧ" << std::endl;
        WSACleanup();
        return -1;
    }

    // ׽
    sockaddr_in hint;
    hint.sin_family = AF_INET;
    hint.sin_port = htons(DEFAULT_PORT);
    hint.sin_addr.S_un.S_addr = INADDR_ANY;

    if (bind(listenSocket, (sockaddr*)&hint, sizeof(hint)) == SOCKET_ERROR) {
        std::cerr << "׽ʧ" << std::endl;
        closesocket(listenSocket);
        WSACleanup();
        return -1;
    }

    // ʼ
    if (listen(listenSocket, SOMAXCONN) == SOCKET_ERROR) {
        std::cerr << "׽ּ" << std::endl;
        closesocket(listenSocket);
        WSACleanup();
        return -1;
    }

    std::cout << "ڼ˿ " << DEFAULT_PORT << "" << std::endl;

    // ȴ
    sockaddr_in client;
    int clientSize = sizeof(client);
    SOCKET clientSocket = accept(listenSocket, (sockaddr*)&client, &clientSize);
    if (clientSocket == INVALID_SOCKET) {
        std::cerr << "ܿͻӳ" << std::endl;
        closesocket(listenSocket);
        WSACleanup();
        return -1;
    }

    // HTTP
    HandleHttpRequest(clientSocket);

    // ر׽
    closesocket(clientSocket);
    closesocket(listenSocket);

    //  Winsock
    WSACleanup();

    return 0;
}
